--[[

	Known Schematics

	Martin Karer / Sezz, 2014
	http://www.sezz.at

--]]

local KS = {};

-----------------------------------------------------------------------------

function KS:New(o)
	o = o or {};
	setmetatable(o, self);
	self.__index = self;
	return o;
end

function KS:Init()
	Apollo.RegisterAddon(self, false, "", { "MarketplaceAuction" });
end

-----------------------------------------------------------------------------

local HighlightKnownSchematics = function(self, aucCurr, wndParent, bBuyTab)
	self:_BuildListItem(aucCurr, wndParent, bBuyTab);

	if (bBuyTab) then
		local itemCurr = aucCurr:GetItem();
		if (itemCurr:GetActivateSpell() and itemCurr:GetActivateSpell():GetTradeskillRequirements() and itemCurr:GetActivateSpell():GetTradeskillRequirements().bIsKnown) then
			local tAuctions = wndParent:GetChildren();
			local wndAuction = tAuctions[#tAuctions];
			wndAuction:SetSprite("BasicSprites:WhiteFill");
			wndAuction:SetBGColor("33ff0000");
		end
	end
end

function KS:OnLoad()
	local tMarketplaceAuction = Apollo.GetAddon("MarketplaceAuction");
	if (not tMarketplaceAuction) then return; end

	-- Cannot hook BuildListItem now, so we'll hook it when Initialize() is called...
	tMarketplaceAuction._Initialize = tMarketplaceAuction.Initialize;
	tMarketplaceAuction.Initialize = function(self)
		self:_Initialize();

		if (self._BuildListItem) then return; end

		self._BuildListItem = self.BuildListItem;
		self.BuildListItem = HighlightKnownSchematics;
	end
end

-----------------------------------------------------------------------------

local KSInst = KS:New();
KSInst:Init();
